#!/bin/sh
#
# Configuration script for program and system locations
# By W.H.Scholten, 1998 - 2000
#
# This file is public domain.
#
# Go go gadget copter.


# Default/other script
cd Config
Ask="sh ./Choose.sh"

PREFIX="/usr/local"

# Set some global defaults
bindir="$PREFIX""/bin"
shrdir="$PREFIX""/share"
libdir="$PREFIX""/lib"
vardir="/var"
mandir="$PREFIX""/man"
incdir="$PREFIX""/include"


########## Figure out what kind of system we are on:
system=`uname`
if [ "X$system" = "X" ]; then
	system=`$Ask 'uname failed: What is your system?' "$system"`
fi


########## Ask the user
echo
done="false"
while [ "$done" = "false" ]; do
	# show current values
	echo "  Install & include Locations:"
	echo "    0. base                       = $PREFIX"
	echo "    (N.B. Changing this changes 1-5 to defaults from base)"
	echo
	echo "  Installation locations:"
	echo "    1. includes                   = $incdir"
	echo "    2. binaries                   = $bindir"
	echo "    3. shared data files          = $shrdir"
	echo "    4. libraries/local data files = $libdir"
	echo "    5. man pages (base directory) = $mandir"
	echo
	echo "  Misc:"
	echo "    6. variable data              = $vardir"
	echo
	echo "  Header locations for libaries used:"
	echo "       none necessary at the moment"

	choice="`$Ask "Which one? " 'Done'`"
	case $choice in
	    0 ) PREFIX=`$Ask 'Install base ?' "/usr/local"`
		bindir="$PREFIX""/bin"
		shrdir="$PREFIX""/share"
		libdir="$PREFIX""/lib"
		vardir="/var"
		mandir="$PREFIX""/man"
		incdir="$PREFIX""/include"
		;;
	    1 ) incdir=`$Ask 'Where do you want the headers installed?' "$incdir"`
		;;
	    2 ) bindir=`$Ask 'Where do you want to install binaries?' "$bindir"`
		;;
	    3 ) shrdir=`$Ask 'Where do you want data files installed?' "$shrdir"`
		;;
	    4 ) libdir=`$Ask 'Where do you want libraries installed?' "$libdir"`
		;;
	    5 ) mandir=`$Ask 'Where do you want the man pages (base directory)?' "$mandir"`
		;;
	    6 ) vardir=`$Ask 'Where do you want variable data stored?' "$vardir"`
		;;
	    * ) done="true"
		;;
	esac
done


# Create a new makeflags.sys file
rm -f makeflags.sys
echo
echo "Creating new makeflags.sys..."

cf="makeflags.sys"
echo "OS = "$system > $cf
echo "BINDIR = "$bindir >> $cf
echo "LIBDIR = "$libdir >> $cf
echo "SHRDIR = "$shrdir >> $cf
echo "VARDIR = "$vardir >> $cf
echo "MANDIR = "$mandir >> $cf
echo "HEADERDIR = "$incdir >> $cf
echo

## Now combine all makeflags files into one
## (gets around an annoying pmake/gmake 'feature' of not looking the directory
## of the included file for nested includes. And -I sucks.)

sh ./Makeflags.sh

# EOF
