/* GSI - general sound interface
 *
 * gsifile (util.h):  utility functions & data tables.
 *
 * By W.H.Scholten 1998 - 2000
 *
 * This software is placed in the public domain and can be used freely
 * for any purpose. It comes without any kind of warranty, either
 * expressed or implied, including, but not limited to the implied
 * warranties of merchantability or fitness for a particular purpose.
 * Use it at your own risk. the author is not responsible for any damage
 * or consequences raised by use or inability to use this program.
 */


#ifndef _GSI__file__util_h
#define _GSI__file__util_h

extern char *sample_fileformat_names[];
extern int   bytes_per_sample[];
extern char *sample_type_names[];


char *song_fileformat_name(int type);

int  sample_fileformat(char *name);
int  sample_num_from_name(char *name);
int  sample_num_from_type(int type);
char *sample_fileformat_name(int format);
char *midi_format_str(int format);

void status_check(char *wrt, int status, char *input);
void range_check(char *wrt, int value, int _min, int _max);

void replace_ctrl_chars(char *str);

#define MY_ALLOC__FATAL   1
#define MY_ALLOC__RETURN  2

int  my_realloc(char **ptr, int new_len, int error_handling);


#endif /* _GSI__file__util_h */
