/* GSI - general sound interface
 *
 * api.h (synth API functions)
 *
 * By W.H.Scholten 1998 - 2000
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__gsisynth__api_h
#define _GSI__gsisynth__api_h


#define GSISYTNH_HW gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status


/* *** Device attachment: */
char *api_attach_synth_device (char *device, int i);
char *api_attach_synth (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int i);


/* **** Synthesizer control functions: */
int  api_open_synth (GSISYTNH_HW);
int  api_init_synth (GSISYTNH_HW /*, int synth_type*/);
int  api_close_synth (GSISYTNH_HW);
int  api_reset_synth (GSISYTNH_HW);
int  api_synth_buffer_status (GSISYTNH_HW);
void api_synth_set_timeout (GSISYTNH_HW, struct timeval *timeout);
int  api_write_synth (GSISYTNH_HW);
int  api_synth_buffer_full (GSISYTNH_HW);


/* **** Synthesizer sequencer control functions: */
void api_seq_prepare (gsi_song_playstatus_t *d);

void api_seq_pause (gsi_song_playstatus_t *d);
void api_seq_continue (gsi_song_playstatus_t *d);
void api_seq_start_timer (gsi_song_playstatus_t *d);
void api_seq_wait_time (gsi_song_playstatus_t *d, int ticks);

void api_seq_stop_note (gsi_song_playstatus_t *d, int chn, int note, int vel);
void api_seq_start_note (gsi_song_playstatus_t *d, int chn, int note, int vel);
void api_seq_key_pressure (gsi_song_playstatus_t *d, int chn, int note, int vel);
void api_seq_control (gsi_song_playstatus_t *d, int chn, int p1, int p2);
void api_seq_chn_pressure (gsi_song_playstatus_t *d, int chn, int vel);
void api_seq_bender (gsi_song_playstatus_t *d, int chn, int p1, int p2);

void api_seq_midi_out (gsi_song_playstatus_t *d, int ch, int data);

int  api_seq_flush (gsi_song_playstatus_t *d);

int  api_seq_set_instrument (gsi_song_playstatus_t *d, int chn, int pgm);


/* **** Functions at midi level: */
int  api_reset_midi (gsi_song_playstatus_t *spdata);


/* **** Data: */
extern int rpn_msb[ 16 ];
extern int rpn_lsb[ 16 ];


#endif /* _GSI__gsisynth__api_h */
