/* GSI - general sound interface
 *
 * oss_includes.h (OSS synth includes)
 *
 * By W.H.Scholten 2000
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__gsisynth__api__oss_includes_h
#define _GSI__gsisynth__api__oss_includes_h

#if USE_OSS

#ifdef OSS_INCLUDES

/* Commercial OSS */
#  include OSS_INCLUDES"/soundcard.h"

#  if  USE_AWE_SYNTH
#    include OSS_INCLUDES"/awe_voice.h"
#  endif

#  if  USE_GUS_SYNTH
#    include OSS_INCLUDES"/ultrasound.h"
#  endif

#  define USE_OSS_SEQ   1

#else

#if defined(__OpenBSD__) || defined(__NetBSD__)

#  include <soundcard.h>

#else

/* linux, FreeBSD: OSS-free */
#ifdef __linux__
#  include <linux/soundcard.h>
#  if  USE_AWE_SYNTH
#    include <linux/awe_voice.h>
#  endif
#  if  USE_GUS_SYNTH
#    include <linux/ultrasound.h>
#  endif
#endif /* linux */

#ifdef __FreeBSD__
#  include <machine/soundcard.h>
#  if  USE_AWE_SYNTH
#    include <machine/awe_voice.h>
#  endif
#  if  USE_GUS_SYNTH
#    include <machine/ultrasound.h>
#  endif
#  include <errno.h>
#endif /* FreeBSD */

#  if  USE_GUS_SYNTH
#    ifndef GUS_INSTRUMENT_DIR
#      error "GUS_INSTRUMENT_DIR not defined"
#    endif
#  endif

#if defined(__OpenBSD__) || defined(__NetBSD__)
/* SEQ_* stuff not implemented in the OSS emulation */
#  define USE_OSS_SEQ   0
#else
#  define USE_OSS_SEQ   1
#endif

#endif

#endif /* OSS_INCLUDES */

#ifndef SAMPLE_TYPE_AWE32
#  define SAMPLE_TYPE_AWE32 0x20
#endif

#endif /* USE_OSS */

#endif /* _GSI__gsisynth__api__oss_includes_h */
