/* GSI - general sound interface
 *
 * instrument.h
 *
 * By W.H.Scholten 1998
 *
 * This file is released to the public domain.
 */

#ifndef _GSI__gsisynth__instrument_h
#define _GSI__gsisynth__instrument_h

#include <gsi/whs_types.h>


/* GSI_INSTRUMENT_* are defined in synth_data.h; are these still needed ? */
#define _INSTRUMENT_NONE            0

#define _INSTRUMENT_OPL2            1
#define _INSTRUMENT_OPL3            2
#define _INSTRUMENT_OPL2_USER       3 /* non standard instrument loaded from a file or program memory */
#define _INSTRUMENT_OPL3_USER       4 /* ditto */


#define _INSTRUMENT_GUS_8BIT        1
#define _INSTRUMENT_GUS_16BIT       2
#define _INSTRUMENT_GUS_8BIT_USER   3 /* non standard instrument loaded from a file or program memory */
#define _INSTRUMENT_GUS_16BIT_USER  4 /* ditto */


/* samples, intermediate structure (data will be put in instrument struct)
 * This will be used for custom instrument making */
struct sample_header {
	char      name[7];
	byte      fractions;
	int32     len;
	int32     loop_start;
	int32     loop_end;
	uint16    base_freq;
	int32     low_note;
	int32     high_note;
	int32     base_note;
	int16     detune;
	byte      panning;

	byte      envelope_rate[6];
	byte      envelope_offset[6];

	byte      tremolo_sweep;
	byte      tremolo_rate;
	byte      tremolo_depth;

	byte      vibrato_sweep;
	byte      vibrato_rate;
	byte      vibrato_depth;

	char      modes;

	int16     scale_frequency;
	uint16    scale_factor;
};


#endif /* _GSI__gsisynth__instrument_h */
