/* GSI - general sound interface
 *
 * synth_null.c (for API's that don't have provision for synth hardware)
 *
 * Lower level API dependencies:
 *   - none
 *
 *
 * Copyright (C) W.H.Scholten 1998 - 2001
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


/*__________________INCLUDES___________________*/
//#include <gsi/gsisynth_config.h>
#include <gsi/config.h>

/* Compile this code for all API's without hardware synthesizer support. */
#if (USE_DEV_AUDIO || USE_FBSD || USE_OPENBSD_AUDIO)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include <gsi/whs_types.h>
//#include <gsi/whs_defines.h>
#define DEBUG_PREFIX "GSISYNTH_"
//#include <gsi/gsi_debug.h>
//#include <gsi/device.h>

#include "../gsisynth.h"


/*__________________VARIABLES___________________*/


/*__________________PROTOTYPES___________________*/
char *api_attach_synth_device(char *device, int i) {
	return NULL;
}

char *api_attach_synth(gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int i) {
	return NULL;
}


int api_init_synth (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {
	return 0;
}

/*---------------------------------------------------------------------------*
 *      Close (the pseudo synth device?).
 *---------------------------------------------------------------------------*/
int api_close_synth (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status)
{
	return 0;
}

int synth_null_done (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) { return 0; }

int api_reset_synth(gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {
	return 0;
}

/*---------------------------------------------------------------------------*
 *      Open (the pseudo synth device?).
 *---------------------------------------------------------------------------*/
int api_synth_null_open (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status)
{
	//synth[dev].synth_rate = 100;
	return -1;
}


// write data to synth
int  api_write_synth(gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {
	return 0;
}


/*---------------------------------------------------------------------------*
 *      Instruments.
 *---------------------------------------------------------------------------*/
int  synth_null_load (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int type, int pgm) { return -1; }
int  synth_null_clear_instrument (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int type, int pgm) { return 0; }
int  synth_null_clear_instruments (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) { return 0; }
int  synth_null_write_instrument(gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int pgm, int instrument_type, int instrument_len, char *instrument_data) { return -1; }


/*---------------------------------------------------------------------------*
 *      Some sequencer buffer management functions.
 *---------------------------------------------------------------------------*/
/* Buffer status: 0=empty, 1=used, 2=full */
int api_synth_buffer_status(gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {

	return 0;
}

// is the sequencer (or buffer) ready to accept data or not?
int api_synth_buffer_full(gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {

	return False;
}
#endif /* USE_DEV_AUDIO || USE_FBSD || USE_OPENBSD_AUDIO */


/*      EOF synth_null.c */
