/* GSI - general sound interface
 *
 * play.c - 
 *
 * Lower level API dependencies: 
 *
 *
 * Copyright (C) W.H.Scholten 1999 - 2001
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



/*__________________INCLUDES___________________*/
//#include <gsi/gsisynth_config.h>
#include <gsi/config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gsi/whs_types.h>
#define DEBUG_PREFIX "GSISYNTH_"
//#include <gsi/gsi_debug.h>

#include "gsisynth.h"
#include "api.h"



/*__________________VARIABLES___________________*/
gsisynth_device_t **gsisynth_devices = NULL;
gsisynth_devicedata_t **gsisynth_devicedata = NULL;

int  gsisynth_num_synths = 0;

int  gsisynth_verbose = False;

int  gsisynth_rate; /* One rate for all devices. */



/*__________________PROGRAM___________________*/
/* attach, detach
 */
char *gsisynth_attach_device (char *device, int i) {
	return api_attach_synth_device(device, i);
}

// useful?
int  gsisynth_detach_device (gsisynth_device_t *hw) {
	return -1;
}


/* open, close
 */
int gsisynth_open (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {
//	hw->open(hw, hw_status);

	return 0;
}


int gsisynth_close (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {
	hw->close(hw, hw_status);

	return 0;
}


/* initialize */
int gsisynth_init (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int modus) {
	hw->init(hw, hw_status /*, modus*/);

	return 0;
}


int  gsisynth_load_instrument (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int pgm) {
	if (hw == NULL || hw_status == NULL) return -1;

	if (hw->load_instrument != NULL)
		return hw->load_instrument(hw, hw_status, pgm);

	return -1;
}


int  gsisynth_set_instrument_from_data (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int pgm, int type, int size, void *data) {
	if (hw == NULL || hw_status == NULL) return -1;

	if (hw->write_instrument != NULL)
		return hw->write_instrument(hw, hw_status, pgm, type, size, data);
	return -1;
}


int  gsisynth_clear_instrument (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int pgm) {
	if (hw == NULL || hw_status == NULL) return -1;

	if (hw->clear_instrument != NULL)
		return hw->clear_instrument(hw, hw_status, pgm);

	return -1;
}

int  gsisynth_clear_instruments (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {
	if (hw == NULL || hw_status == NULL) return -1;

	if (hw->clear_instruments != NULL)
		return hw->clear_instruments(hw, hw_status);

	return -1;
}


// buffer:
//int  gsisynth_seq_flush (gsi_song_playstatus_t *d) {
//	api_synth_seq_flush (d);
//	//NEW return hw->write(hw, hw_status);
//}

int  gsisynth_buffer_full (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {
	return (hw->buffer_status(hw, hw_status) == 2);
}

int  gsisynth_buffer_status (gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {
	return hw->buffer_status(hw, hw_status);
}


/*      EOF play.c */
