/* GSI - general sound interface
 *
 * gsicddb_disc_id.c - calculates the disc id.
 *
 * Lower level API dependencies:
 *  - none
 *
 *
 * Copyright (C) 2000 W.H.Scholten
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

int gsicddb_sum_of_digits(int val) {
	int ret = 0;

	while (val) {
		ret = ret + (val % 10);
		val = val / 10;
	}

	return ret;
}

int gsicddb_disc_id(int cd) {
	int  checksum = 0;
	int  disc_id;
	int  num_tracks;
	int  total_seconds;

	for (i=0; i<cd_data[ cd ].numtracks; i++) {
		checksum += gsicddb_sum_of_digits( (cd_data[ cd ][i].m*60*75 + cd_data[ cd ][i].s*75 + cd_data[ cd ][i].f)/75 );
	}

	num_tracks = cd_data[ cd ].tracks;
	total_seconds = (cd_data[ cd ] [ num_tracks ].m*60*75 + cd_data[ cd ] [ num_tracks ].s*75 + cd_data[ cd ] [ num_tracks ].f - cd_data[ cd ] [ 0 ].m*60*75 + cd_data[ cd ] [ 0 ].s*75 + cd_data[ cd ][0].f) / 75;

	disc_id = ((checksum & 0xFF) << 24) | (total_seconds << 8) | last;

	return disc_id;
}

/* EOF */
