/* GSI - general sound interface
 *
 * api.h (cd API functions)
 *
 * 2000 by W.H.Scholten
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__gsicd__api_h
#define _GSI__gsicd__api_h

//#include <gsi/cd_data.h>
extern int api_cd_can_open_without_medium;
/*  Flags wether we can open the device if there's no CD in it. (N.B. If not,
 *  then it's not possible to eject/insert the tray unless there's a CD in it).
 */

int api_cd_init(int cd);
int api_cd_stop(int cd);
int api_cd_pause(int cd);
int api_cd_resume(int cd);
int api_cd_eject(int cd);
int api_cd_insert(int cd);
int api_cd_select_slot(int cd, int slot);
int api_cd_set_output_volume(int cd, int volume);
int api_cd_get_output_volume(int cd);
int api_cd_set_channels(int cd, int cmd);
int api_cd_get_status(int cd, gsicd_status_t *cd_pos);
int api_cd_get_contents(int cd);
int api_cd_play(int cd, gsicd_track_info_t *start, gsicd_track_info_t *end);

int api_cd_get_slots(int cd);
/*  0 if not usable (on an unsupported OS), -1 on error (unable to determine
 *  the number for some reason), and the number of slots (> 0) if we're sure
 *  about this number. */

#if defined(__FreeBSD__) || defined(__OpenBSD__) || defined(__NetBSD__)
#  define GSICD_API_BSD
#elif defined(__linux__)
#  define GSICD_API_LINUX
#elif defined(__bsdi__)
#  define GSICD_API_BSDI
#else
#  define GSICD_API_NULL
#  warning "I don't know the CD OS/API calls for your OS, using null output."
#endif

#endif /* _GSI__gsicd__api_h */
