/* GSI - general sound interface
 *
 * cd_null.c - libgsicd: cd calls for OS/API's that are not supported (yet).
 *
 * Lower level API dependencies:
 *   -
 *
 *
 *
 * Copyright (C) 2000 W.H.Scholten
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#ifdef GSICD_API_NULL
int api_cd_can_open_without_medium = True;

int api_cd_init(int cd) {
	return -1;
}


int api_cd_stop(int cd) {
	return -1;
}


int api_cd_pause(int cd) {
	return -1;
}


int api_cd_resume(int cd) {
	return -1;
}


int api_cd_eject(int cd) {
	return -1;
}


int api_cd_insert(int cd) {
	return -1;
}


int api_cd_select_slot(int cd, int slot) {
	return -1;
}


int api_cd_set_output_volume(int cd, int volume) {
	return -1;
}


int api_cd_get_output_volume(int cd) {

	return -1;
}


int api_cd_set_channels(int cd, int cmd)
{
	return -1;
}


int api_cd_get_status(int cd, gsicd_status_t *cd_pos) {
	return -1;
}


int api_cd_get_contents(int cd) {
	return -1;
}


int api_cd_play(int cd, gsicd_track_info_t *start, gsicd_track_info_t *end) {
	return -1;
}


int api_cd_get_slots(int cd) {
	return 0;
}
#endif /* GSICD_API_NULL */

/*      EOF cd_null.c */
