/* GSI - general sound interface
 *
 * api.h (pcm API functions)
 *
 * 1996 - 2000 by W.H.Scholten
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__gsipcm__api_h
#define _GSI__gsipcm__api_h

#include <gsi/pcm_data.h>

int api_setup_pcm (GSIPCM_HW, int samplerate, int channels, int type, int log2_fragsize);
/*  Returns 0 if OK, < 0 if an error occurred. */

int api_pcm_set_mode (GSIPCM_HW, int modus);

int api_pcm_write (GSIPCM_HW, void *buf, int bytes_to_write);
/*  Returns number of bytes written, < 0 on error. */

int api_pcm_write_space (GSIPCM_HW);
/*  Returns number of bytes that can be written without blocking. */

int api_pcm_buffer_status (GSIPCM_HW, int *writespace, int *readdata);
/* REMOVE? */

#endif /* _GSI__gsipcm__api_h */
