/* GSI - general sound interface
 *
 * types.c - gsif library, data types & sizes.
 *
 * Lower level API dependencies: none (standard file system stuff)
 *
 *
 * Copyright (C) 1998 - 2000 W.H.Scholten
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


/*__________________INCLUDES___________________*/
#include "../include/gsif.h"


/*---------------------------------------------------------------------------*
 *      Bytes used per sample: 0 = query for invalid/unknown format.
 *---------------------------------------------------------------------------*/
/* alaw, mulaw, 8 , 8_s, 16, 16_le, 24, 24_le, adpcm 4 bit / 3 bit / 5 bit */
//int  _gsif_Bps[]= { 1, 1, 1, 1, 2, 2, 3, 3, -4, -3, -5};

/* alaw, mulaw, 8 , 16, 24, 8_s, 16_le, 24_le, adpcm 4 bit / 3 bit / 5 bit */
int  _gsif_Bps[]= { 1, 1, 1, 2, 3, 1, 2, 3, -4, -3, -5 };
/* negative = bits, not bytes. */

/* same input range: (to compare types when converting to the best one) */
int  _gsif_type_value[] = { 2, 3, 1, 5, 7, 0, 4, 6 };


int gsif_sizeof_sample(int format) {
	if (format >= 0 && format < GSI_NUM_SAMPLE_TYPES)
		return _gsif_Bps [format];

	return 0;
}

/*      EOF types.c */
