/* Keith Packard's software midi synthesizer
 *
 * This file is public domain.
 */


#ifndef _GSI__gsimidi_pcm__midi_data_h
#define _GSI__gsimidi_pcm__midi_data_h


#define VOLUME_BITS       8

extern const float  volumeTable [ 1 << VOLUME_BITS ];
extern const double equal440Table[12];
extern const double equal415Table[12];
extern const double mean415Table[12];
extern const double werk3Table[12];
extern const double vallottiTable[12];

#define NOTE_TABLE_BASE   69 /* A440 index in equal440 table */

//OLD extern double       noteTable[128];
extern const double centsTable[100];
extern const double semiTable[128];

#define SINE_BITS         9

extern const double sineTable [ 1 << SINE_BITS ];


#define INTERP_BITS       6
#define INTERP_MASK       ((1 << INTERP_BITS) - 1)

extern const float  midiInterp [ 1 << INTERP_BITS ];


extern const char  *patchNames [ 128 ];

/* Also in kpmidi.h: */
#define MIN_DRUM    35
#define MAX_DRUM    81

extern const char  *drumNames [ MAX_DRUM - MIN_DRUM + 1 ];

#endif /* _GSI__gsimidi_pcm__midi_data_h */
