/* Keith Packard's software midi synthesizer
 *
 * This file is public domain.
 */


#ifndef _GSI__gsimidi_pcm__midi_to_pcm_h
#define _GSI__gsimidi_pcm__midi_to_pcm_h

#include "midi_data.h"


#define MAX_MIDI_SAMPLES   131072
#define FIX_INT                17        /* log2(MAX_MIDI_SAMPLES) */
#define FIX_FRACTION           15        /* fraction bits (32 - FIX_INT) */
#define FIX_MASK           0x7fff        /* (1 << FIX_FRACTION) - 1 */

#define FixToInt(f)      ((int) ((f) >> FIX_FRACTION))
#define FixFromInt(i)    (((MidiFix) (i)) << FIX_FRACTION)
#define FixIntPart(f)    ((f) & ~FIX_MASK)
#define FixFracPart(f)   ((f) &  FIX_MASK)
#define FixFromFloat(fl) ((MidiFix) ((fl) * (float) (1 << FIX_FRACTION)))
#define FixToFloat(f)    ((float) (f) / (float) (1 << FIX_FRACTION))
#define FIX_INVALID      ((MidiFix) ~0L)

#define FixToInterp(f)   (((f) >> (FIX_FRACTION-INTERP_BITS)) & INTERP_MASK)
#define FixToFloor(f)    midiInterp[ FixToInterp(f) ]
#define FixToCeil(f)     (1.0f - midiInterp[ FixToInterp(f) ])

#define SineValue(v)     (sineTable[ (v) >> (32 - SINE_BITS) ])

/* Envelope values are stored using this rate: */
#define ENVELOPE_RATE    44100


#endif /* _GSI__gsimidi_pcm__midi_to_pcm_h */
