/* Keith Packard's software midi synthesizer
 * ui.h
 *
 * Defines the UI API (events showing what's changing in the playing).
 *
 * Change to a single event function:
 *  void *gsimidi_pcm_set_callback_function(void (*evf)(void *event_struct));
 *
 * possibly even remove that and use and event list.
 * Or make the default callback an event list store function...
 *
 * This file is public domain.
 */

#ifndef _GSI__gsimidi_pcm__ui_h
#define _GSI__gsimidi_pcm__ui_h

#include "kpmidi.h"

/* Move to a MIDI definition header: */
typedef enum _MidiText {
    MidiTextText = 1,
    MidiTextCopyright,
    MidiTextSequence,
    MidiTextInstrument,
    MidiTextLyric,
    MidiTextMarker,
    MidiTextCue
} MidiText;


/* Midi events: */
void gsimidipcm_UiSetText (MidiData *d, int channel, char *text, MidiText type);
void gsimidipcm_UiSetTime (MidiData *d, int num, int den);
void gsimidipcm_UiSetKey (MidiData *d, int sig, int mode);
void gsimidipcm_UiProgramChange (MidiData *d, int channel, int program);

void gsimidipcm_UiNoteOn (MidiData *d, int channel, int note);
void gsimidipcm_UiNoteOff (MidiData *d, int channel, int note);
void gsimidipcm_UiNoteIdle (MidiData *d, int channel, int note);

void gsimidipcm_UiSetChannelVolume (MidiData *d, int channel);
void gsimidipcm_UiSetTempo (MidiData *d);

#endif /* _GSI__gsimidi_pcm__ui_h */
