/*
 * $Id: debug.h,v 1.1.1.1 1998/02/08 05:26:55 keithp Exp $
 *
 * Modified by W.H.Scholten
 *
 * Copyright  1998 Keith Packard
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Keith Packard not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  Keith Packard makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * KEITH PACKARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL KEITH PACKARD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef _GSI__gsimidi_pcm__utils__debug_h
#define _GSI__gsimidi_pcm__utils__debug_h

#ifdef KPMIDI_DEBUG
#include <gsi/gsi_debug.h>

extern
void
_gsimidipcm_debug_print(long DebugPrintLevel, char *DebugMessage, ...);

#  define DEBUG_FAILURE    0
#  define DEBUG_INIT       1
#  define DEBUG_INITV      2
#  define DEBUG_INPUT      3
#  define DEBUG_REPLY      4
#  define DEBUG_NETWORK    5
#  define DEBUG_WAVE       6
#  define DEBUG_PAUSE      7
#  define DEBUG_MIDI       8
#  define DEBUG_NOTE       9
#  define DEBUG_ENVELOPE  10
#  define DEBUG_MIDIWAVE  11
#  define DEBUG_PROGRAM   12
#  define DEBUG_MIDIOUT   13
#  define DEBUG_MIX       14

#  define DPRINT(arg) DEB1(_gsimidipcm_debug_print arg)

#else
/* ! KPMIDI_DEBUG */
#  define DPRINT(arg)
#  undef DEBUG
#  include <gsi/gsi_debug.h>

#endif

#endif /* _GSI__gsimidi_pcm__utils__debug_h */
