/*
 * $Id: match.c,v 1.1 1998/02/26 19:59:23 keithp Exp $
 *
 * Modified by W.H.Scholten
 *
 * Copyright  1998 Keith Packard
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Keith Packard not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  Keith Packard makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * KEITH PACKARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL KEITH PACKARD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#include <string.h>

const char *
match_next (const char *a, char *part)
{
	if (!*a)
		return 0;

	while (*a)
	{
		if (*a == ',')
		{
			*part = '\0';
			return a + 1;
		}
		*part++ = *a++;
	}
	*part++ = '\0';

	return a;
}

int
match_any (const char *a, const char *b)
{
	char apart[256], bpart[256];
	const char *at, *bt;

	for (at = a; (at = match_next (at, apart));)
	{
		for (bt = b; (bt = match_next (bt, bpart));)
		{
			if (!strcmp (apart, bpart))
				return 1;
		}
	}

	return 0;
}
