/* GSI - general sound interface
 *
 * client.h - shared sound server, client management
 *
 * 1998 - 2000 by W.H.Scholten
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__server__client_h
#define _GSI__server__client_h

#include <gsi/gsi_config.h>

#define MAX_CLIENTS   64


extern int  num_clients;
extern struct gsi_client  *client_list[ MAX_CLIENTS ];

extern int  ls; /* listen socket descriptor */
extern int  connection_type; /* GSI_CONNECTION_AF_LOCAL or GSI_CONNECTION_AF_INET */
extern int  af_local_permissions;


int  init_connection (void);
/*   First function to be called before doing any socket IO. */

int  add_client (void);
/*   Tries to add a new client (if there is one..) */

int  initialize_client_data (struct gsi_client *new, int socket_fd);
/*   Initializes the clients main data structure. */

int  remove_client (int client);
/*   */

int  remove_client_data (int client);
/*   Frees all data allocated for the given client, closes socket etc. */


#endif /* _GSI__server__client_h */
