/* GSI - general sound interface
 *
 * config.h - shared sound server, configuration
 *
 * 1998 - 2000 by W.H.Scholten
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__server__conf_h
#define _GSI__server__conf_h

extern int  cd_keep_open;
extern int  allow_AF_INET;
extern int  allow_loading;
extern int  allow_saving;


int  read_server_config (void);
/*   This is called at startup to set some preferences according to the default
 *   config file /etc/gsi.conf or ~/.gsi.conf */

char *get_config_entry (char *filename, char *device, char *entry, int entry_no);
/*   Gets a string for a given type of configuration entry:
 *   e.g. FILL THIS IN!
 */

void check_cd_config (void);
/*   After a change in the cd device name, this is called to see if we want to
 *   keep the CD fd open etc. */


#endif /* _GSI__server__conf_h */
