/* GSI - general sound interface
 *
 * debug.c - sound server debug code
 *
 * Lower level API dependencies:
 *
 *
 * Copyright (C) 1999-2000 W.H.Scholten
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>
#include <string.h>


//#include <gsi/gsi_debug.h>

#include <gsi/gsicd.h>
#include <gsi/gsipcm.h>
//#include <gsi/gsisynth.h>
#include <gsi/gsimixer.h>

#include "debug.h"

#ifdef DEBUG
int debug_level = -1;

/*---------------------------------------------------------------------------*
 *      First function to be called.
 *---------------------------------------------------------------------------*/
int debug_init() {
	debug_level = 0;

	return 0;
}

int  debug_show_devices() {
	/* Temporary: showing all attached devices: */
	fprintf(stderr, "DEVEL INFO: devices:\n");
	{
		int  jj;

		fprintf(stderr, "pcms: %d\n", gsipcm_num_pcms);
		for (jj=0; jj<gsipcm_num_pcms; jj++) {
			fprintf(stderr, "  pcm %d: %s [ %s ]\n", jj, gsipcm_devices[jj]->device, gsipcm_devices[jj]->id);
		}
//		fprintf(stderr, "\nsynths: %d\n", num_synths);
//		for (jj=0; jj<gsisynth_num_synths; jj++) {
//			fprintf(stderr, "  synth %d: %s [ %s ]\n", jj, gsisynth_devices[jj]->device, gsisynth_devices[jj]->id);
//		}
		fprintf(stderr, "\ncds: %d\n", gsicd_num_cds);
		for (jj=0; jj<gsicd_num_cds; jj++) {
			fprintf(stderr, "  cd %d: %s [ %s ]\n", jj, gsicd_devices[jj]->device, gsicd_devices[jj]->id);
		}
	}
	fprintf(stderr, "devices done\n");

	return 0;
}
#endif /* DEBUG */

/*      EOF debug.c */
