/* GSI - general sound interface
 *
 * debug.h
 *
 * dd 1999 - 2000 by W.H.Scholten
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__server__debug_h
#define _GSI__server__debug_h

#include <gsi/config.h>

/* Debug functions return 0 if all ok, -1 if not */
#ifdef DEBUG
int  debug_init(void);
extern int debug_level; /* initialized by init */
int  debug_show_devices(void);
/*   Show attached devices. */

#else
#  define debug_level          -1
#  define debug_init()          0
#  define debug_show_devices()  0
#endif

#define debug_do(lvl, x) if (debug_level >= lvl) { x; };


#endif /* _GSI__server__debug_h */
