/* GSI - general sound interface
 *
 * gsi_server.h
 *
 * by W.H.Scholten 1998 - 2001
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__server__gsi_server_h
#define _GSI__server__gsi_server_h


#include "client_data.h"
//#include <unistd.h>

#define SERVER_NAME "gsi_server"

/* Globals: */
extern char   *server_name;
extern uid_t   pw_uid;      /* user id */
extern gid_t   pw_gid;      /* group id */
extern int     current_client;
extern struct gsi_client *current;
extern int     share_server;
extern int     forced_connection;
/*    do we force with GSI_CONNECTION_AF_INET or GSI_CONNECTION_AF_LOCAL?
 *    otherwise this is GSI_CONNECTION_ANY. */

extern int     af_local_socket_created; /* if created, we may unlink it. */

extern byte   *pcm_final;
/*    final buffer, pointer to buffer used for gsipcm_write. */

extern int     mixer_owner, pcm_owner, synth_owner, cd_owner[ 16 ];

extern int     autoset_pcm, autorelease_pcm;
extern int     pcm_request[ 64 ], pcm_requests;
extern int     total_playnum;

extern int     be_quiet;

/* Prototypes */
void   error_message (char *msg);
void   error_message2 (int error_type, char *msg);
void   log_message (int type, char *format, ...);


#endif /* _GSI__server__gsi_server_h */
