/* GSI - general sound interface
 *
 * slot.h
 *
 * 1996 - 2001 by W.H.Scholten
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__server__load__slot_h
#define _GSI__server__load__slot_h

//int   slot_busy (struct gsis_slot *s);
int   slot_busy (struct gsi_client *c, int slot);
/*    Returns True (1) if the slot is being played on a channel, otherwise
 *    False (0). */

int   init_slot (struct gsis_slot **s, int type);
/*    Allocate necessary space, free unused space. */

int   init_slot_with_sample (struct gsi_client *c, int slot, char *sound_file, int read_header, int data_offset, int data_len);
/*    Sets the slot type and the file from which data will be loaded etc. */

//void  init_sample (struct gsis_slot *s, int samplerate, int channels, int type, int size);
void  init_sample (struct gsi_client *c, int slot, int samplerate, int channels, int type, int size);


//int   load_slot (struct gsis_slot *s);
int   load_slot (struct gsi_client *c, int slot);
/*    Load the sound data into a slot which was given a valid filename earlier.
 *    */

//void  unload_slot (struct gsis_slot *s);
void  unload_slot (struct gsi_client *c, int slot);
/*    Frees the data loaded into slot, can be reloaded at any time.
 *    When free_name is True (=not zero), free_slot is called */

//void  free_slot (struct gsis_slot *s);
int   free_slot (struct gsi_client *c, int slot);
/*    Frees a slot completely. */

void  load_all_slots (struct gsi_client *c);
/*    Calls load_slot for slot 0-255. */

void  unload_all_slots (struct gsi_client *c);
/*    Calls unload_slot for slot 0-255. */

void  free_all_slots (struct gsi_client *c);
/*    Calls free_slot for slot 0-255. */


/* Experimental: */
int   sample_internal_type_of (struct gsi_sample *sample);
/*    Alters sample to the internal format used. */

void  convert_data_to_internal (byte *data, int size, struct gsi_sample *sample);
/*    Do the actual conversion of a block. */

int   convert_slotdata_to_internal (struct gsi_client *c, int slot); /* convert data format */
/*    Above 2 combined. */

int   gsimisc_type (char *type);
/*    String "GSI_8BIT" -> GSI_8BIT etc. */


#endif /* _GSI__server__load__slot_h */
