/* GSI - general sound interface
 *
 * song_play.h
 *
 * By W.H.Scholten 1998 - 2000
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__server__synth__song_play_h
#define _GSI__server__synth__song_play_h

#include <gsi/whs_types.h>
#define _SONG_NONE     0 /* _SONG_NO_STATUS ? */
#define _SONG_PLAYING  1
#define _SONG_PAUSED   2


/* available synthesizer hardware; if multiple, use highest numbered one found
 * (at the moment GUS) by default. */
#define MIDI_HW                 -1 /* should make this 254? */
#define SYNTH_HW_NONE            0
#define SYNTH_HW_FM              1
#define SYNTH_HW_OPL             2
#define SYNTH_HW_GUS             3
#define SYNTH_HW_AWE32           4
#define SYNTH_PCM_EMULATION    255


/* ** High level song functions: */
int  song_finished (int client, int ch);
/*  ^ True if buffer=empty & elapsed_time >= song_end_time */

int  song_init (int client, int ch);
int  song_play_events (int client, int ch, int max_dt);
//void song_prepare_new (int client, int ch);


/* ** Internal song playing functions: timing */
void   song_init_time (int client, int ch, double offset);
double song_get_time (int client, int ch);


#endif /* _GSI__server__synth__song_play_h */
