/* GSI - general sound interface
 *
 * synth.c: general synth functions
 *
 *
 * Copyright (C) W.H.Scholten 1999 - 2000
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#if 0 /* disabled */
/*__________________INCLUDES___________________*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#include <gsi/whs_types.h>
#define DEBUG_PREFIX "GSIS_SYNTH_"
//#include <gsi/gsi_debug.h>
#include <gsi/gsif_midi.h>

#include <gsi/gsisynth.h>

#include "../../gsi_server.h"
#include "../../client.h" /* for client_list */
#include "synth.h"


/*__________________EXTERNALS___________________*/


/*__________________VARIABELEN___________________*/
int  best_synth = -1; /* Index into card table. */
int  best_synth_device = -2; /* SYNTH_HW_OPL etc. */



/*---------------------------------------------------------------------------*
 *      Functions for each device.
 *---------------------------------------------------------------------------*/
int  close_synth(int dev) {
	int  i;
	gsisynth_devicedata_t *hw_status = current->song_status->hw_status;

#ifdef DEBUG
	if (dev > gsisynth_num_synths) return -1;
	if (hw_status->fd_ct <= 0) return -1;
	if (hw_status->fd <= 0) return -1;
#endif

	for (i=0; i<16; i++) {
//??		if (hw_status->fd == gsisynth_devices[i].fd)
//??			hw_status->fd_ct--;
	}
	if (! hw_status->fd_ct) {
//X		close(gsisynth_devices[dev].fd);
		close(hw_status->fd);
	}
	return 0;
}


/* For instrument loading, e.g. OPL can load all pgms, GUS with 1M or even   *
 * less not, GUS with lots of memory can load all etc.                       *
 */
int  instrument_size(gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status, int pgm) {
	return hw->sizeof_default_instrument(hw, hw_status, pgm);
}

int  available_memory(gsisynth_device_t *hw, gsisynth_devicedata_t *hw_status) {
	return hw->instrument_memory_available(hw, hw_status);
}
#endif /* disabled */

/*      EOF synth.c */

