/* GSI - general sound interface
 *
 * string_util.c - shared sound server, string functions.
 *
 * Lower level API dependencies: none
 *
 *
 * Copyright (C) 1996 - 2000 W.H.Scholten
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


/*__________________INCLUDES___________________*/
//#include <stdio.h>
//#include <stdlib.h>
#include <string.h>


/*---------------------------------------------------------------------------*
 *      To load a file, convert filename -> absolute filename from the given
 *      directory.
 *---------------------------------------------------------------------------*/
char temp_string[ 1024 ];
char *absolute_file_name(char *dir, char *filename) {
	int old_len;

	if (dir == NULL) {
		temp_string[ 0 ] = 0;
	}
	else {
		strncpy(temp_string, dir, 500);
		temp_string[ 500 ] = 0;

		if (strlen(temp_string) > 0 && temp_string[ (int) strlen(temp_string) - 1 ] != '/')
			strcat (temp_string, "/");
	}

	old_len = strlen(temp_string);


	if (filename[0] == '/' )
		strncpy (temp_string, filename, 500); /* absolute path */
	else
		strncat (temp_string, filename, 500); /* relative from the sounddir */
	temp_string[ old_len + 500 ] = 0;

	return temp_string;
}


/*      EOF string_util.c */
