void malloc_error() {
	fprintf(stderr, "failed to allocate memory\n");
	exit(1);
}

char *cd_devices[] = {
	"/dev/cd0c",
	"/dev/cd1c"
};
#define NUM_CDS  (sizeof(cd_devices) / sizeof(char *))

void alloc_cd_device() {
	int  i;

	/* allocate space for device & status */
	gsicd_devices = malloc(sizeof(void *) * NUM_CDS);
	if (gsicd_devices == NULL)
		malloc_error();

	for (i=0; i<NUM_CDS; i++) {
		gsicd_devices[i] = calloc(1, sizeof(gsicd_device_t) * 1);
		if (gsicd_devices[i] == NULL)
			malloc_error();
	}

	gsicd_status = malloc(sizeof(void *) * NUM_CDS);
	if (gsicd_status == NULL)
		malloc_error();

	for (i=0; i<NUM_CDS; i++) {
		gsicd_status[i] = calloc(1, sizeof(gsicd_devicedata_t) * 1);
		if (gsicd_status[i] == NULL)
			malloc_error();
	}

	gsicd_num_cds = NUM_CDS;

	/* setup devices */
	printf("Using the following devices (edit alloc_device.inc.c to change this):\n");
	for (i=0; i<NUM_CDS; i++) {
		printf("CD device %d: %s\n", i, cd_devices[i]);
		gsicd_devices [ i ]->device = cd_devices[i];
		gsicd_status[ i ]->fd = -1;
		gsicd_devices[ i ]->num_slots = 5; /* test */
	}
}
