/* GSI - general sound interface
 *
 * formats (formats.c):
 *   Shows supported file formats.
 *
 * By W.H.Scholten 2001
 *
 * This software is placed in the public domain and can be used freely
 * for any purpose. It comes without any kind of warranty, either
 * expressed or implied, including, but not limited to the implied
 * warranties of merchantability or fitness for a particular purpose.
 * Use it at your own risk. the author is not responsible for any damage
 * or consequences raised by use or inability to use this program.
 */


/*
 * export TEST_DEBUG_LEVEL= n for debug output.
 */


/*__________________INCLUDES___________________*/
#include <stdio.h>
#include <stdlib.h>

/* These two includes are really for internal GSI use .. */
#include <gsi/whs_types.h>
#define DEBUG_PREFIX "TEST_"
//#include <gsi/gsi_debug.h>

#include <gsi/gsif.h>



/*__________________PROGRAM___________________*/
void use() {
	fprintf(stderr, "\nHELP on formats:\n" \
			"formats\n" \
			"\n");
	exit(0);
}


int main(int argc, char *argv[]) {
	int  status;
	int  i;
	char *format, *description;

	if (argc != 1) {
		use();
	}

	for (i=0; ; i++) {
		status = gsif_get_format(&format, &description, i);
		if (status < 0) break;
		printf("format %2d: %s (%s)\n", i, format, description);
	}

	return 0;
}

/* EOF formats.c */
