/* GSI - general sound interface
 *
 * load test (load.c):
 *   Tests file loading/identifying with large offsets etc.
 *
 * By W.H.Scholten 1998 - 2001
 *
 * This software is placed in the public domain and can be used freely
 * for any purpose. It comes without any kind of warranty, either
 * expressed or implied, including, but not limited to the implied
 * warranties of merchantability or fitness for a particular purpose.
 * Use it at your own risk. the author is not responsible for any damage
 * or consequences raised by use or inability to use this program.
 */


/*
 * export TEST_DEBUG_LEVEL= n for debug output.
 */


/*__________________INCLUDES___________________*/
#include <stdio.h>
#include <stdlib.h>

/* These two includes are really for internal GSI use .. */
#include <gsi/whs_types.h>
#define DEBUG_PREFIX "TEST_"
//#include <gsi/gsi_debug.h>

#include <gsi/gsif.h>



/*__________________PROGRAM___________________*/
void use() {
	fprintf(stderr, "\nHELP on load:\n" \
			"load <file> <offset>\n" \
			"\n");
	exit(0);
}


int main(int argc, char *argv[]) {
	struct gsi_sound *snd;
	int  status;

	if (argc != 3) {
		use();
	}

	snd = gsif_load_sample(argv[1], strtol(argv[2], NULL, 16), &status);
	if (snd == NULL) {
		printf("\nFile \"%s\": can't load file (gsif: %s)\n", argv[1], gsif_strerror(status));
	}

	gsif_free_sound(snd);

	return 0;
}

/* EOF load.c */
