/* GSI - general sound interface
 *
 * mus_to_midi (main.c):
 *   Test with: ./mus_to_midi /usr/lib/games/doom/doom1.wad 0x1a2208
 *
 * By W.H.Scholten 1998 - 2001
 *
 * This software is placed in the public domain and can be used freely
 * for any purpose. It comes without any kind of warranty, either
 * expressed or implied, including, but not limited to the implied
 * warranties of merchantability or fitness for a particular purpose.
 * Use it at your own risk. the author is not responsible for any damage
 * or consequences raised by use or inability to use this program.
 */


/*
 * export TEST_DEBUG_LEVEL= n for debug output.
 */


/*__________________INCLUDES___________________*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* These two includes are really for internal GSI use .. */
#include <gsi/whs_types.h>
#define DEBUG_PREFIX "TEST_"
//#include <gsi/gsi_debug.h>

#include <gsi/gsif.h>



/*__________________PROGRAM___________________*/
void use() {
	fprintf(stderr, "\nHELP on mus_to_midi:\n" \
			"mus_to_midi <file> <offset>\n" \
			"\n");
	exit(0);
}


int main(int argc, char *argv[]) {
	struct gsi_song *sng;
	int  status;

	if (argc != 3) {
		use();
	}

	sng = gsif_load_song(argv[1], strtol(argv[2], NULL, 16), &status);
	if (sng == NULL) {
		printf("\nFile \"%s\": can't load song (gsif: %s)\n", argv[1], gsif_strerror(status));
	}
	else {
		free(sng->filename);
		sng->filename = strdup("mustest.mid");
		gsif_save_midi(sng);
	}

	gsif_free_song(sng);

	return 0;
}

/* EOF main.c */
