/* interleave.c: Interlinieert 2 of meer .raw 8 bit unsigned audio bestanden
 *
 * By W.H.Scholten 1997 - 2000
 *
 * This file is public domain.
 */


/*__________________INCLUDES___________________*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Comment out for english text: */
#define NL

#ifdef NL
#  define NL_T(t) t
#  define ENG_T(t)
#else
#  define NL_T(t)
#  define ENG_T(t) t
#endif


#define max(x,y) ((x)<(y) ? (y): (x))


/*__________________PROGRAMMA___________________*/
void use() {
#ifdef NL
	printf("\nHULP VOOR INTERLEAVE:\n"
		   "interleave -h\n"
		   " of:\n"
		   "interleave <bestand 1> ... <bestand n> (n=2,3,4)\n\n"
		);
#else
	printf("\nHELP ON INTERLEAVE:\n"
		   "interleave -h\n"
		   " or:\n"
		   "interleave <file 1> .. <file n> (n=2,3,4)\n\n"
		);
#endif
}


int main(int argc, char *argv[]) {
	char bestand_uit[ 100 ];
	FILE *fpin[4], *fpuit;
	unsigned char byte;
	int  i, j;
	int  file_len[4];
	int  len;

	strcpy(bestand_uit, "interleaved.raw");

	if (argc == 1 || (argc == 2 && !strcmp(argv[1], "-h"))) {
		use();
		exit(0);
	}

	printf(
		NL_T("\ninterleave:\n")
		ENG_T("\ninterleave:\n")
		);


	if (argc > 5) {
		fprintf(stderr, NL_T("maximaal 4 bestanden\n") ENG_T("4 files maximum\n"));
		exit(1);
	}

	len = 0;
	for (i=0; i< argc-1; i++) {
		fpin[i] = fopen(argv[i+1], "r");
		if (fpin[i] == NULL) {
			printf(
				NL_T("Bestand ")
				ENG_T("File ")
				);
			printf(argv[i+1]);
			printf(
				NL_T(" is niet te openen\n\n")
				ENG_T(" cannot be opened\n\n")
				);
			exit(1);
		}
		fseek(fpin[i], 0L, SEEK_END);
		file_len[i] = ftell(fpin[i]);
		fseek(fpin[i], 0L, SEEK_SET);
		len = max(len, file_len[i]);
	}

	fpuit = fopen(bestand_uit, "w");
	if (fpuit == NULL) {
		fprintf(stderr,
				NL_T("%s kan niet geopend worden om naar te schrijven\n\n")
				ENG_T("%s cannot be opened for writing\n\n")
				, bestand_uit
				);
		exit(1);
	}

	/* schrijf de gegevens */
	for (i=0; i<len; i++) {
		for (j=0; j<argc-1; j++) {
			if (fread(&byte, 1, 1, fpin[j]) == 0)
				byte = 0;
			else
				byte = byte ^ 128; /* unsigned 8 bit -> signed 8 bit */
;
			fwrite(&byte, 1, 1, fpuit);
		}
	}

	return 0;
}

/* EOF interleave.c */
