#! /bin/sh
#
# Utility to set LD_LIBRARY_PATH to the directories of GSI libraries.
# This script will detect if it's run instead of being sourced.
#
# By W.H.Scholten, dd 2000
# This file is released to the public domain.
#
echo

thisprogr=`basename /X/$0`
# The /X/ fixes the problem with bash returning -bash and then basename barfing

if [ "X$thisprogr" = "Xset_libpath.sh" ]; then
    echo "No point in executing this file"
    echo "Use: . set_libpath.sh [ path-of-gsi-source ]"
    echo
    exit 1
fi

if [ "X"$1 != "X" ]; then
    MYDIR=$1
    echo "Using "$1" as the path of the gsi source"
else
    MYDIR=~/projecten/gsi-0.9.6
    echo "Assuming the gsi source tree is in: "$MYDIR
    echo "(if it isn't, run . set_libpath.sh <path of the gsi source>)"
fi
echo

LIBS="gsi gsif device/gsimixer device/gsipcm device/gsicd device/gsisynth gsimidi_pcm"

export LD_LIBRARY_PATH
LD_LIBRARY_PATH=""
for i in $LIBS; do
    LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$MYDIR/lib/$i;
done

echo "LD_LIBRARY_PATH is now:"
echo $LD_LIBRARY_PATH
echo
