#! /bin/sh
#
# Utility to set MANPATH to the directories of GSI manpages.
# This script will detect if it's run instead of being sourced.
#
# By W.H.Scholten, dd 2000
# This file is released to the public domain.
#
echo

thisprogr=`basename /X/$0`
# The /X/ fixes the problem with bash returning -bash and then basename barfing

if [ "X$thisprogr" = "Xset_manpath.sh" ]; then
    echo "No point in executing this file"
    echo "Use: . set_manpath.sh [ path-of-gsi-source ]"
    echo
    exit 1
fi

if [ "X"$1 != "X" ]; then
    MYDIR=$1
    echo "Using "$1" as the path of the gsi source"
else
    MYDIR=~/projecten/gsi-0.9.6
    echo "Assuming the gsi source tree is in: "$MYDIR
    echo "(if it isn't, run . set_manpath.sh <path of the gsi source>)"
fi
echo

MANDIRS=". lib/gsi lib/gsif lib/gsipcm lib/gsimixer lib/gsicd lib/gsisynth lib/gsimidi_pcm server applications/file applications/player"

export MANPATH
MANPATH=""
for i in $MANDIRS; do
    MANPATH=$MANPATH:$MYDIR/$i/doc;
done

echo "MANPATH is now:"
echo $MANPATH
echo
