#! /bin/sh
#
# Utility to set PATH to the directories of GSI programs.
# This script will detect if it's run instead of being sourced.
#
# By W.H.Scholten, dd 2000
# This file is released to the public domain.
#
echo

thisprogr=`basename /X/$0`
# The /X/ fixes the problem with bash returning -bash and then basename barfing

if [ "X$thisprogr" = "Xset_path.sh" ]; then
    echo "No point in executing this file"
    echo "Use: . set_path.sh [ path-of-gsi-source ]"
    echo
    exit 1
fi

if [ "X"$1 != "X" ]; then
    MYDIR=$1
    echo "Using "$1" as the path of the gsi source"
else
    MYDIR=~/projecten/gsi-0.9.6
    echo "Assuming the gsi source tree is in: "$MYDIR
    echo "(if it isn't, run . set_path.sh <path of the gsi source>)"
fi
echo

LIBS="applications/player applications/file server utils"

export PATH
#PATH=""
for i in $LIBS; do
    PATH=$PATH:$MYDIR/lib/$i;
done

echo "PATH is now:"
echo $PATH
echo
